from dataclasses import dataclass
from typing import Dict, List, Optional, Set, Union

from gbso.cpu import CPU, CPUState
from gbso.insn import Insn
from gbso.regs import R8


@dataclass
class Program:
    outputs: Set[Union[R8, int]]
    insns: List[Insn]
    init_state: Optional[CPUState] = None

    def execute(self) -> CPU:
        cpu = CPU(state=self.init_state)
        for insn in self.insns:
            insn.exec(cpu)
        return cpu
